/**
 * Ce programme sert  montrer l'utilisation
 * de quelques algorithmes de la classe Collections.

 * @author Philippe Langlais
 * @author Mohamed Lokbani (qcqs commentaires en plus)

 * @version 1.2
 */


import java.util.*;

// -------------------------------------------------------
//  la classe principale
// -------------------------------------------------------

public class TestCollections {
    
    static private int entiers[] = {23,2,4,5,6,6,9,8,12};
    static private double flottants[] = {12.3, 1.2, 3.2, 5.6, 3.1, 78.2, 4.2};
    
    // ---------------------------------------------------
    static void afficheTableaux() {
	System.out.println("entiers: ");
	for (int i=0; i<entiers.length; i++)  System.out.print(entiers[i] + " ");
	System.out.println("");
	
	System.out.println("flottants: ");
	for (int i=0; i<flottants.length; i++)  System.out.print(flottants[i] + " ");
	System.out.println("");
    }
    // ---------------------------------------------------
    static void collectionArray() {
	int indice;
	
	// trier efficacement un tableau en une seule instruction !
	Arrays.sort(flottants);
	Arrays.sort(entiers);
	
	afficheTableaux();
	
	// rechercher efficacement un element dans une table triee
	if ( (indice = Arrays.binarySearch(entiers,12)) >=0 )
	    System.out.println("12 existe dans entiers a l'indice " + indice);
	
	System.out.println("4.2 dans flottants ? " + Arrays.binarySearch(flottants,4.2));
	
	// remplissage de tout ou partie d'un tableau avec un element
	Arrays.fill(entiers,10);
	Arrays.fill(flottants,2,4,0.0);
	afficheTableaux();
	
	double flottants2 [] = new double [flottants.length];
	System.arraycopy(flottants,0,flottants2,0,flottants.length);
	System.out.println("flottants == flottants2 ? " + Arrays.equals(flottants,flottants2));
	
    }
    // ---------------------------------------------------
    public static void main (String args []) {
	
	collectionArray();
	
    }
}
